#include <AR/ar.h>
#include "object.h"


@interface ARMarkerDetector : QCPatch
{
	QCStringPort *inputCameraCalibrationFile;
	QCStructurePort *inputPatternFiles;
	QCNumberPort *inputPatternMillimeters;
	QCIndexPort *inputThreshold;
	QCImagePort *inputImage;
	QCStructurePort *outputMarkerStructure;
	
	ARParam	cameraParam;
	NSMutableArray *patternPaths;
}

+(BOOL)isSafe;
+(BOOL)allowsSubpatchesWithIdentifier:(id)identifier;
+(int)executionModeWithIdentifier:(id)identifier;
+(int)timeModeWithIdentifier:(id)identifier;
-(id)initWithIdentifier:(id)identifier;
-(BOOL)setup:(QCOpenGLContext*)context;
-(void)cleanup:(QCOpenGLContext*)context;
-(void)enable:(QCOpenGLContext*)context;
-(void)disable:(QCOpenGLContext*)context;
-(BOOL)execute:(QCOpenGLContext*)context time:(double)time arguments:(NSDictionary*)arguments;

@end
